package caida.tools;
import java.awt.*;

/***********************************************************************
*  GridPanel			written  09/04/1997
*  by Bradley Huffaker		modified 11/09/1997
*  Cooperative Association for Internet Data Analysis
*  Goal: This creates a simple way to use GridBaglayout.  It allows 
*  the the add of objects to a container with with it auto 
*  creating a GridBagConstraint for it.
*
************************************************************************
************************************************************************
By accessing this software, GRIDPANEL, you are duly informed of and 
agree to be bound by the conditions described below in this notice:
 
This software product, GRIDPANEL, is developed by Bradley Huffaker, and
copyrighted(C) 1998 by the University of California, San Diego (UCSD),
with all rights reserved.  UCSD administers the NSF grant to CAIDA,
number NCR-9711092, under which this code was developed. 
 
There is no charge for GRIDPANEL software. You can redistribute it and/or
modify it under the terms of the GNU General Public License, v. 2 dated
June 1991 which is incorporated by reference herein.  GRIDPANEL is
distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that the use of
it will not infringe on any third party's intellectual property
rights.
 
You should have received a copy of the GNU GPL along with the GRIDPANEL
program.  Copies can also be obtained from
http://www.gnu.org/copyleft/gpl.html or by writing to
 
                        University of California, San Diego
                        SDSC/CAIDA
                        9500 Gilman Dr., MS-0505
                        La Jolla, CA 92093 - 0505  USA
 
  Or contact INFO@CAIDA.ORG
***********************************************************************/

public class GridPanel extends GridBagConstraints
{
	static final GridBagLayout gridbag = new GridBagLayout();
	Container container;

	/** GridPanel(Container container) ******************************
	*	Allows the the the container to be passed in as a argument
	******************************************************************/
	public GridPanel(Container container_input)
	{
		container  = container_input;
		container.setLayout(gridbag);
	}

	/** GriDPanel() **************************************************
	*	Default constuctor. Will create a panel to use.
	******************************************************************/
	public GridPanel()
	{
		container = new Panel();
		container.setLayout(gridbag);
	}

	/** Container getContainer() **************************************
	*	Returns the container that all the objects are added to.
	*******************************************************************/
	public Container getContainer() { return container; }

	/** add(Component component, int grid_x, int grid_y, int grid_width, 
	*	int grid_height, int fill, int anchor, double weight_x, 
	*	double weight_y, int top, int left, int bottom, int right)
	* 	Allow you to add items to the container with differing degrees 
	*	of control
	*******************************************************************/
	public void add(Component component, int grid_x, int grid_y, int grid_width, 
		int grid_height, int fill, int anchor, double weight_x, double weight_y,
		int top, int left, int bottom, int right)
 	{
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = grid_x; c.gridy = grid_y;
		c.gridwidth = grid_width; c.gridheight = grid_height;
		c.fill = fill; c.anchor = anchor;
		c.weightx = weight_x; c.weighty = weight_y;

		if (top+bottom+left+right >0)
			c.insets = new Insets(top,left,bottom,right);
		gridbag.setConstraints(component, c);
		container.add(component);
	}
	public void add(Component component, int grid_x, int grid_y, int grid_width,
	int grid_height, int fill, int anchor)
	{
		double weight_x = 0.3;
		double weight_y = 0.0;
		int top = 0;
		int left = 0;
		int bottom = 0;
		int right = 0;
		add(component,grid_x, grid_y,grid_width, grid_height,fill,anchor,	
			weight_x, weight_y, top, left, bottom, right);
	}

	
	public void add(Component component, int grid_x, int grid_y, int fill, int anchor)
	{
		int grid_width = 1;
		int grid_height = 1;
		add(component,grid_x, grid_y,grid_width, grid_height,fill
			,anchor);
	}
	
	public void add(Component component, int grid_x, int grid_y, int fill)
	{
		anchor = CENTER;
		add(component, grid_x, grid_y, fill, anchor);
	}

	public void add(Component component, int grid_x, int grid_y)
	{
		fill = BOTH;
		add(component, grid_x, grid_y, BOTH);
	}

	public void addSize(Component component,int grid_x, int grid_y
		, int grid_width, int grid_height)
	{
		anchor = CENTER;
		fill = BOTH;
		add(component,grid_x, grid_y,grid_width, grid_height,fill
			,anchor);
	}
}
