package caida.otter;
import java.awt.*;

/*****************************************************************************
* File: HelpFrame.java	Class: HelpFrame
* Goal: To provide a frame that display help information. 
*
******************************************************************************
******************************************************************************
*  By accessing this software, HELPFRAME, you are duly informed of
*  and agree to be bound by the conditions described below in
*  this notice:
*
*  This software product, HELPFRAME, is developed by Bradley Huffaker, and
*  copyrighted(C) 1998 by the University of California, San Diego (UCSD),
*  with all rights reserved.  UCSD administers the NSF grant to CAIDA,
*  number NCR-9711092, under which this code was developed. 
*
*  HELPFRAME is a free software. You can redistribute it and/or modify it
*  under the terms of the GNU Public License v.2 as
*  published by UCSD and is incorporated by reference herein.  HELPFRAME is
*  distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF MERCHANTABILITY
*  OR FITNESS FOR A PARTICULAR PURPOSE or that the use of it will not
*  infringe on any third party's intellectual property rights.
*
*  You should have received a copy of the CAIDA General Public
*  License v.1 along with the HELPFRAME program.  If for any reason you
*  have not received a copy, please write to
*
*                       University of California, San Diego
*                       SDSC/CAIDA
*                       9500 Gilman Dr., MS-0505
*                       La Jolla, CA 92093 - 0505  USA
*
*  Or contact INFO@CAIDA.ORG
*****************************************************************************/ 
public class HelpFrame extends Frame
{

 static final int ABOUT = 0;
 final String ABOUT_STR =  
	"                       Otter\n"+
	"                  A visualization of\n"+
	"             The Global Caching Hierarchy   \n"+
	"\n"+
	"                          by\n"+
	"              Bradley Huffaker (01/17/98)\n"+
	"              Jaeyeon Jung (03/18/98)\n"+
	"\n"+
	"        Cooperative Association for Internet\n"+
	"                     Data Analysis\n"+
        "\n\n"+
        "------------------------------------------------------------------\n"+
        "                PSGr - A Java PostScript Generator\n"+
        "(C) 1999 Ernest J. Friedman-Hill and Sandia National Laboratories\n"+
        "------------------------------------------------------------------\n";

 static final int COMMANDS = 1;
 final String COMMANDS_STR = 
	"  Options in the pull down menu\n"+
	"---------------------------------\n"+
	"\n"+
	"File\n"+
	"------\n"+
	"  Clear Network\n"+
	"     Clears all nodes and links that are current displayed\n"+
	"  Center Network\n"+
	"     Centers the viewing display on the location that is the average\n"+
	"     distance from all the nodes\n"+
	"  Load Network\n"+
	"     Searchs a directory (./Data for standalone, a URL for Applet)\n"+
	"     and then lists the files in  a pop up window.  The user may\n"+
	"     then choose one to download. The applet only display `.fvl'\n"+
	"     files, while the standalone displays all files.\n"+
	"  Exit\n"+
	"     Exit from Otter\n"+

	"\n"+
/*
	"Build Tools\n"+
	"------\n"+
	"  Add Node\n"+
	"     Adds node to current network when the mouse is clicked inside\n"+
	"     the display.\n"+
	"  Add Link\n"+
	"     Add a link between two existing nodes.  First click and hold\n"+
	"     down the button of the mouse over a node.  Then drag the mouse \n"+
	"     over to another node. Then let the button go.\n"+
	"  Remove Object\n"+
	"     Move the mouse over either a link or a node and then click on\n"+
	"     and the object will be removed.\n"+

	"\n"+
*/
 	"Interaction\n"+
	"------\n"+
	"  Select Root\n"+
	"     Changes a node into a root node or the other way around\n"+
	"     when the mouse is clicked on it.\n"+
	"  Select Object\n"+
	"     Allows the user to select nodes.  Selected nodes will change\n"+
	"     there postions when the mouse button is held down and the \n"+
	"     mouse is dragged around inside of the display.\n"+
	"  Select by Name\n"+
	"     Selects all nodes that contain a string in thier name.\n"+
	"  Select Tree\n"+
	"     Select a node and all it's children.  Where all it's children\n"+
	"     means those nodes which are placed below it in the format\n"+
	"     process.\n"+
	"  Move \n"+
	"     Will move the relative location of all the nodes when the user\n"+
	"     holds down the mouse and drags it around.\n"+
	"  Deselect All Objects\n"+
	"     Deselects any selected nodes\n"+
	"  Auto Arrange\n"+
	"     Attempts to place nodes in a tree which grows from the\n"+
	"     root nodes away from the center.  This is done to all nodes.\n"+

	"\n"+
	"Resolution\n"+
	"------\n"+
	"  High res - all links are trangles (slower)\n"+
	"  Low res - all links are only lines (recommanded when move nodes)\n"+

	"\n"+
	"Zoom\n"+
	"------\n"+
	"  Will scale the current dimenions of the node locations\n"+
	"  by the amount indicated.\n"+

	"\n"+
	"Color by\n"+
	"------\n"+
	"  HTTP Request - will create a color scale and then color each\n"+
	"	link and node by the humber of HTTP requests it gets\n"+
	"  Default Colors - Returns the link's an node's color to their\n"+
	"	defualt colors.\n"+
	
	"\n"+
	"Help\n"+
	"------\n"+
	"  Brings up a pop up window that will display\n"+
	"  Commands\n"+
	"    This menu\n"+
	"  About\n"+
	"    Information about this program like date, programmer ...\n"+
	"  Overview\n"+
	"    Some useful information about link and node charateristics\n";

 static final int OVERVIEW = 2;
 static final String OVERVIEW_STR = 
	"  General Overview\n"+
	"-----------------------\n"+
	"\n"+
	" Nodes\n"+
	"--------\n"+
	"   Red - root node\n"+
	"   Green - selected node\n"+
	"   Size - distance from a root\n"+

	"\n"+
	" Links\n"+
	"--------\n"+
	"   Thick - at the server\n"+
	"   Thin - at the client\n"+

	"\n"+
	" Applet vs. Standalone\n"+
	"-----------------------\n"+
	"  Speed - The standalone has much better preformace\n"+
	"  Download - The Applet auto load's the URL\n"+
	"  Source - The Applet are provied a URL\n"+
	"           The standalone looks in ./Data\n";
	
 // Holds the message
 TextArea area;
 // Used to make the window go away
 Button Cancel;

 public HelpFrame(int type)
 {
	super("Help");
	
 	area = new TextArea();
	area.setEditable(false);
	setType(type);

	Panel bottom_panel = new Panel();
	Cancel = new Button("Cancel");

	bottom_panel.setLayout(new FlowLayout());
	bottom_panel.add(Cancel);

	setLayout(new BorderLayout());
	add("Center",area);
	add("South",bottom_panel);
	pack();
 }

 public void setType(int type)
 {
	switch (type)
	{
		case ABOUT:    area.setText(ABOUT_STR) ; break;
		case COMMANDS: area.setText(COMMANDS_STR); break;
		case OVERVIEW: area.setText(OVERVIEW_STR); break;
		default: area.setText("Unknow type");
	}
 }

 public boolean handleEvent(Event event)
 {
	if (event.id == Event.ACTION_EVENT && event.target == Cancel)
		hide();
	return super.handleEvent(event);
 }
}
