package caida.otter;
import java.awt.*;

/***********************************************************************
*  Values				written  02/14/98
*  by Bradley Huffaker          
*  Cooperative Association for Internet Data Analysis
*  version 1.0
*
*  Goal: This holds the arrays of floats or strings that form a attribute
*	for a Display object.
*
************************************************************************
************************************************************************
By accessing this software, VALUES, you are duly informed of and 
agree to be bound by the conditions described below in this notice:
 
This software product, VALUES, is developed by Bradley Huffaker, and
copyrighted(C) 1998 by the University of California, San Diego (UCSD),
with all rights reserved.  UCSD administers the NSF grant to CAIDA,
number NCR-9711092, under which this code was developed. 
 
There is no charge for VALUES software. You can redistribute it and/or
modify it under the terms of the GNU General Public License, v. 2 dated
June 1991 which is incorporated by reference herein.  VALUES is
distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that the use of
it will not infringe on any third party's intellectual property
rights.
 
You should have received a copy of the GNU GPL along with the VALUES
program.  Copies can also be obtained from
http://www.gnu.org/copyleft/gpl.html or by writing to
 
                        University of California, San Diego
                        SDSC/CAIDA
                        9500 Gilman Dr., MS-0505
                        La Jolla, CA 92093 - 0505  USA
 
  Or contact INFO@CAIDA.ORG
***********************************************************************/

public class Values
{
	static public final char FLOATS = 'f';
	static public final char STRINGS = 's';
	
	String[] strings;
	float[] floats;
	
	ValuesGroup group;

	public Values(String[] strings_input,ValuesGroup group_input)
	{	
		strings = strings_input;
		group = group_input;
	}
	
	public Values(float[] floats_input)
	{
		floats = floats_input;
	}
	
	public float[] getFloats() { return floats; }
	public String[] getStrings() { return strings; }
	
	public char getType() 
	{
		if (floats != null)
			return FLOATS;
		else
			return STRINGS;
	}
	
	public ValuesGroup getGroup() { return group;}
}
